package {

import flash.display.Sprite;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.ui.Keyboard;

	import patterncraft.Vehicle;

	import patterncraft.raven.Raven;

	import patterncraft.tank.SiegeTank;


	[SWF (width=800, height=600)]
	public class StateWithStrategyDemo extends Sprite {

		private var _message:TextField;

		private var _current:Vehicle;

		public function StateWithStrategyDemo()
		{
			var tank:SiegeTank = new SiegeTank();
			tank.x = 100;
			tank.y = 100;
			tank.addEventListener(MouseEvent.CLICK, onVehicleClick);
	        addChild(tank);

			var raven:Raven = new Raven();
			raven.x = 200;
			raven.y = 200;
			raven.addEventListener(MouseEvent.CLICK, onVehicleClick);
			addChild(raven);

			_message = new TextField();
			_message.width = 800;
			_message.height = 20;
			_message.mouseEnabled = false;
			addChild(_message);

			_message.text = "current: None";

			stage.addEventListener(MouseEvent.CLICK, onStageClick);
			stage.addEventListener(KeyboardEvent.KEY_UP, onKeyUp)
	    }

		private function onKeyUp(event:KeyboardEvent):void
		{
			switch (event.keyCode)
			{
				case Keyboard.NUMBER_1://keyboard 1
					if(_current is Raven) _current.setState(Raven.STATE_FLY);
					if(_current is SiegeTank) _current.setState(SiegeTank.STATE_SPEED);
					break;

				case Keyboard.NUMBER_2://keyboard 2
					if(_current is Raven) _current.setState(Raven.STATE_SWIM);
					if(_current is SiegeTank) _current.setState(SiegeTank.STATE_TANK);
					break;

				case Keyboard.NUMBER_3://keyboard 3
					if(_current is SiegeTank) _current.setState(SiegeTank.STATE_SIEGE);
					break;
			}
		}

		private function onStageClick(event:MouseEvent):void
		{
			// Если никого не выбрали ниче не делаем
			if (!_current) return;

			// Если кликнули по машине этот обработчик пропускаем. Если этого не сделать сработают оба обработчика.
			if (event.target is Vehicle) return;


			var tweenVars:Object = {x:event.stageX,  y:event.stageY, scaleX:1, scaleY:1, rotation:0};
			_current.move(tweenVars);
		}

		private function onVehicleClick(event:MouseEvent):void
		{
			_current = event.currentTarget as Vehicle;
			_message.text = "current: " + String(_current);
		}
	}
}
