/**
 * User: John Lindquist
 * Date: Aug 31, 2010
 * Time: 2:24:01 AM
 */
package patterncraft.raven
{
	import patterncraft.move.Swim;
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.TimerEvent;
	import flash.utils.Timer;


	internal class SwimState extends EventDispatcher implements IRavenState
    {
        private var raven:Raven;

        public function SwimState(raven:Raven)
        {
            this.raven = raven;
        }

        public function get damage():Number
        {
            return 0;
        }

        public function get canMove():Boolean
        {
            return true;
        }

        public function get color():uint
        {
            return 0x0000cc;
        }

		public function apply():void
		{
			raven.mouseEnabled = true;
			raven.alpha = 1;

			raven.moveBehavior = new Swim();
		}

		public function transitionTo(state:String):void
		{
			raven.mouseEnabled = false;
			raven.alpha = 0.3;
			raven.moveBehavior = null;

			var timer:Timer = new Timer(1000, 1);
			timer.addEventListener(TimerEvent.TIMER, onTransitionComplete);
			timer.start();
		}

		private function onTransitionComplete(event:TimerEvent):void
		{
			event.currentTarget.reset();
			dispatchEvent(new Event(Event.COMPLETE));
		}
	}
}