/**
 * User: John Lindquist
 * Date: Aug 31, 2010
 * Time: 2:24:01 AM
 */
package patterncraft.tank
{
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.TimerEvent;
	import flash.utils.Timer;

	import patterncraft.move.Teleport;


	internal class SpeedState extends EventDispatcher implements ISiegeTankState
    {
        private var siegeTank:SiegeTank;

        public function SpeedState(siegeTank:SiegeTank)
        {
            this.siegeTank = siegeTank;
        }

        public function get damage():Number
        {
            return 0;
        }

        public function get canMove():Boolean
        {
            return true;
        }

        public function get color():uint
        {
            return 0x0000cc;
        }

		public function apply():void
		{
			siegeTank.mouseEnabled = true;
			siegeTank.alpha = 1;

			siegeTank.moveBehavior = new Teleport();
		}

		public function transitionTo(state:String):void
		{
			siegeTank.mouseEnabled = false;
			siegeTank.alpha = 0.3;
			siegeTank.moveBehavior = null;

			var timer:Timer = new Timer(1000, 1);
			timer.addEventListener(TimerEvent.TIMER, onTransitionComplete);
			timer.start();
		}

		private function onTransitionComplete(event:TimerEvent):void
		{
			event.currentTarget.reset();
			dispatchEvent(new Event(Event.COMPLETE));
		}
	}
}